// don't want this executing when building graphs
if($OFFLINE_NAV_BUILD)
   return;
$trainingDifficulty = $pref::trainingDifficulty;
$pref::trainingDifficulty = $pref::KantarDifficulty;

echo("-----------------Running Capto Kantar 1");
exec("scripts/CaptoTrainingSupport1.cs");
exec("scripts/aiCaptosObjectives.cs");
activatePackage(CaptoKantar1);
activatePackage(CaptoTrainingSupport1);

// variables based on skill level
$numberOfEnemies[1] = 10;
$numberOfEnemies[2] = 14;
$numberOfEnemies[3] = 18;
$numberOfTeammates = (2*$pref::KantarDifficulty);  // better match Number you bring in or less
$missionBotSkill[1] = 0.4;
$missionBotSkill[2] = 0.7;
$missionBotSkill[3] = 1.1;
$Tank1 = "Dead";
$Tank2 = "Dead";
$Tank3 = "Dead";
$CaptoTankWaitFlag[1] = 0;
$CaptoTankWaitFlag[2] = 0;
$CaptoTankWaitFlag[3] = 0;
$EnemyDead = 0;
$FriendlyDead = 0;
$CTKillFlag = 0;
$PlayerKills = 0;
$DamageType::AssaultPhoton      = 44;

$DeathMessageCTurretKill[$DamageType::AssaultPhoton, 0] = '\c0%4 torches %1 with a photon particles!';
$DeathMessageCTurretKill[$DamageType::AssaultPhoton, 1] = '\c0%4 fries %1 with a photon particles!';
$DeathMessageCTurretKill[$DamageType::AssaultPhoton, 2] = '\c0%4 lights up %1 with a photon particles!';

$DeathMessageTurretKill[$DamageType::AssaultPhoton, 0] = '\c0%1 is killed by a photon blast.';
$DeathMessageTurretKill[$DamageType::AssaultPhoton, 1] = '\c0%1\'s body now marks the location of a photon blast.';
$DeathMessageTurretKill[$DamageType::AssaultPhoton, 2] = '\c0%1 is fried by a photon blast.';

// Derm Tank---- They dont use the mortar well so I gave them a new weapons
// Its from a mod I wrote called Freebase!
// If you actually read this and you play a Single player then play
// some other mission u may not have turret mortars any more for the Tank
// SOrry
//-------------------------------------
// ASSAULT PHOTON (ParicleEmitter)
//-------------------------------------

datablock ExplosionData(AssaultPhotonSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 50;

   offset = 4.0;

   playSpeed = 1.5;

   sizes[0] = "0.5 0.5 0.5";
   sizes[1] = "1.5 1.5 1.5";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(AssaultPhotonSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 100;

   offset = 5;

   playSpeed = 1.0;

   sizes[0] = "1.75 1.0 1.75";
   sizes[1] = "2.5 2.5 2.5";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(AssaultPhotonSubExplosion3)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 0;

   offset = 0.0;

   playSpeed = 0.7;


   sizes[0] = "2.5 2.5 2.5";
   sizes[1] = "5.0 5.0 5.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

//-------------------------------------
// ASSAULT PHOTON (ParicleEmitter)
//-------------------------------------

datablock ParticleData(AssaultPhotonExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1450;
   lifetimeVarianceMS   = 150;
   textureName          = "particleTest";
   colors[0]     = "0.5 0.2 0.2 1.0";
   colors[1]     = "0.5 0.1 0.1 0.0";
   sizes[0]      = 1;
   sizes[1]      = 2;
};

datablock ParticleEmitterData(AssaultPhotonExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 12;
   velocityVariance = 1.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "AssaultPhotonExplosionParticle";
};



//-------------------------------------
// ASSAULT PHOTON (Shockwave)
//-------------------------------------

datablock ShockwaveData(AssaultPhotonShockwaveA)
{
   width = 4.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 10;
   acceleration = 10.0;
   lifetimeMS = 1500;
   height = 2.0;
   verticalCurve = 5.0;
   is2D = false;

   delayMS = 250;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.4 0.5 0.50";
   colors[1] = "0.7 0.3 0.2 0.25";
   colors[2] = "0.4 0.1 0.1 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = false;
};

datablock ShockwaveData(AssaultPhotonShockwaveB)
{
   width = 4.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 10;
   acceleration = 10.0;
   lifetimeMS = 2000;
   height = 1.0;
   verticalCurve = 1.0;
   is2D = true;

   delayMS = 250;

   texture[0] = "special/shockwave5";
   texture[1] = "special/shockwave5";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.4 0.5 0.50";
   colors[1] = "0.7 0.3 0.2 0.25";
   colors[2] = "0.4 0.1 0.1 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = false;
};

//-------------------------------------
// ASSAULT PHOTON (explosion)
//-------------------------------------

datablock ExplosionData(AssaultPhotonExplosion)
{
   soundProfile   = PlasmaBarrelExpSound;
   particleEmitter = AssaultPhotonExplosionEmitter;
   particleDensity = 250;
   particleRadius = 1.25;
   faceViewer = true;

   shockwave[0] = AssaultPhotonShockwaveA;
   shockwave[1] = AssaultPhotonShockwaveB;

   subExplosion[0] = AssaultPhotonSubExplosion1;
   subExplosion[1] = AssaultPhotonSubExplosion2;
   subExplosion[2] = AssaultPhotonSubExplosion3;

   shakeCamera = true;
   camShakeFreq = "15.0 12.0 12.0";
   camShakeAmp = "15.0 15.0 15.0";
   camShakeDuration = 2.5;
   camShakeRadius = 40.0;
};

//-------------------------------------
// ASSAULT PHOTON (projectile)
//-------------------------------------

datablock ItemData(AssaultPhotonAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.5;
   friction = 0.6;
   pickupRadius = 1;

   computeCRC = true;
};

datablock LinearFlareProjectileData(AssaultPhoton)
{
   projectileShapeName = "plasmabolt.dts";
   scale               = "3.0 3.0 3.0";
   faceViewer          = true;
   directDamage        = 1.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.5;
   damageRadius        = 25.0;
   kickBackStrength    = 4000;
   radiusDamageType    = $DamageType::AssaultPhoton;

   explosion           = AssaultPhotonExplosion;
   splash              = PlasmaSplash;

   dryVelocity       = 80.0;
   wetVelocity       = -1;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 5000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   //activateDelayMS = 100;
   activateDelayMS = -1;

   size[0]           = 0.3;
   size[1]           = 1.0;
   size[2]           = 0.2;


   numFlares         = 25;
   flareColor        = "1 0.25 0.25";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/expflare";

	sound        = PlasmaProjectileSound;
   fireSound     = PlasmaFireSound;
   wetFireSound  = PlasmaFireWetSound;
   dryFireSound  = AssaultMortarDryFireSound;

   hasLight    = true;
   lightRadius = 4.0;
   lightColor  = "1 0.25 0.25";
};

datablock TurretImageData(AssaultMortarTurretBarrel)
{
   shapeFile = "turret_tank_barrelmortar.dts";
   mountPoint = 0;

   projectile = AssaultPhoton;
   projectileType = LinearFlareProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 85.00;
   minEnergy = 85.00;
   useCapacitor = true;
   emap = true;


   // Turret parameters
   activationMS      = 1000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 300;
   degPerSecPhi      = 500;
   attackRadius      = 350;

   // State transitions
   stateName[0]                  = "Activate";
   stateTransitionOnNotLoaded[0] = "Dead";
   stateTransitionOnLoaded[0]    = "ActivateReady";

   stateName[1]                  = "ActivateReady";
   stateSequence[1]              = "Activate";
   stateSound[1]                 = AssaultTurretActivateSound;
   stateTimeoutValue[1]          = 1;
   stateTransitionOnTimeout[1]   = "Ready";
   stateTransitionOnNotLoaded[1] = "Deactivate";

   stateName[2]                    = "Ready";
   stateTransitionOnNotLoaded[2]   = "Deactivate";
   stateTransitionOnTriggerDown[2] = "Fire";
   stateTransitionOnNoAmmo[2]      = "NoAmmo";

   stateName[3]                = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3]        = 0.3;
   stateFire[3]                = true;
   stateRecoil[3]              = LightRecoil;
   stateAllowImageChange[3]    = false;
   stateSequence[3]            = "Fire";
   stateSound[3]               = PBLFireSound;
   stateScript[3]              = "onFire";

   stateName[4]                  = "Reload";
   stateTimeoutValue[4]          = 2;
   stateAllowImageChange[4]      = false;
   stateSequence[4]              = "Reload";
   stateTransitionOnTimeout[4]   = "Ready";
   stateTransitionOnNotLoaded[4] = "Deactivate";
   stateTransitionOnNoAmmo[4]    = "NoAmmo";
   stateWaitForTimeout[4]        = true;

   stateName[5]                = "Deactivate";
   stateSequence[5]            = "Activate";
   stateDirection[5]           = false;
   stateTimeoutValue[5]        = 1;
   stateTransitionOnLoaded[5]  = "ActivateReady";
   stateTransitionOnTimeout[5] = "Dead";

   stateName[7]                = "DryFire";
   stateSound[7]               = AssaultMortarDryFireSound;
   stateTimeoutValue[7]        = 1.0;
   stateTransitionOnTimeout[7]  = "NoAmmo";

   stateName[8]                    = "NoAmmo";
   stateSequence[8]                = "NoAmmo";
   stateTransitionOnAmmo[8]        = "Reload";
   stateTransitionOnTriggerDown[8] = "DryFire";
};

package CaptoKantar1 {
//Kantar 1  package functions begin=======================================================
// I put every single function in the package just in case!
// this is called in singleplayer.cs
function getTeammateGlobals()
{
// Every buddy starts out Med Shield Armor They can go from there!
	$TeammateWarnom0 = "Buffy";
	$teammateskill0 = 1.5;
	$teammateVoice0 = Fem1;
	$teammateEquipment0 = 6;
	$teammateGender0 = Female;

	$TeammateWarnom1 = "Willow";
	$teammateskill1 = 0.7;
	$teammateVoice1 = Fem2;
	$teammateEquipment1 = 6;
	$teammateGender1 = Female;

	$TeammateWarnom2 = "Xander";
	$teammateskill2 = 0.9;
	$teammateVoice2 = Male1;
	$teammateEquipment2 = 6;
	$teammateGender2 = Male;

	$TeammateWarnom3 = "WildSide";
	$teammateskill3 = 0.5;
	$teammateVoice3 = Male3;
	$teammateEquipment3 = 6;
	$teammateGender3 = Male;

	$TeammateWarnom4 = "Proteus";
	$teammateSkill4 = 0.5;
	$teammateVoice4 = Male4;
	$teammateEquipment4 = 6;
	$teammateGender4 = Male;

	$TeammateWarnom5 = "Dogkiller";
	$teammateskill5 = 0.7;
    $teammateVoice5 = Male2;
	$teammateEquipment5 = 6;
	$teammateGender5 = Male;

	$TeammateWarnom6 = "Firecrow";
	$teammateskill6 = 0.5;
	$teammateVoice6 = Fem3;
	$teammateEquipment6 = 6;
	$teammateGender6 = Female;

	$TeammateWarnom7 = "Capto";
	$teammateskill7 = 0.9;
    $teammateVoice7 = Male5;
	$teammateEquipment7 = 6;
	$teammateGender7 = Male;

	$TeammateWarnom8 = "Banshee";
	$teammateskill8 = 1.0;
	$teammateVoice8 = Fem5;
	$teammateEquipment8 = 6;
	$teammateGender8 = Female;
}

function CaptoTraining2::InitMap()
{
    // Placed here to lower console spam Training missions have alot of spam!
}

function toggleScoreScreen(%val)
{
   if ( %val )
   {
   if ($PlayerKills == 1)
     %killText = " kill.";
   else
     %killText = " kills.";
   messageClient($player, 0, "\c5You have " @ $PlayerKills @ %killText);
   }
}

function toggleNetDisplayHud( %val )
{
   // Hello, McFly?  This is training!  There's no net in training!
}

function voiceCapture( %val )
{
   // Uh, who do you think you are talking to?
}
// get the ball rolling you need the next function its how your mission is
// started and where you initalize
//------------------------------------------------------------------------------
function startCurrentMission(%game)
{
   // this is for Testing make sure you edit it out before you release the mission
   //setLogMode(1);

   $player.miscMsg[TankEscaped] = "ARRRRRG!!!!  A tank has escaped and is distroying our supply lines you idiot!\nPlay again?";
   $player.miscMsg[TanksDead] = "Great Job, all the tanks are dead mopping up the rest of the derms should be easy!";
   $player.miscMsg[DermsDead] = "Great Job. You finished off all the derms!";

   $player.objHud[$currentMission, obj1, 1] = "Defend the bridge.";
   $player.objHud[$currentMission, obj1, 2] = "Don't let any tanks through!";

   $player.text[Derm_Score, wav] ="voice/Announcer/ANN.bdscore.WAV";
   $player.text[Derm_Win, wav] ="voice/Announcer/ANN.bdwin.WAV";


    // this is the command that actually updates that box in the bottom right
    updateTrainingObjectiveHud(obj1);

//   ServerConnection.setBlackOut(true, 0);
     beginCaptoTraining2Intro();
}

// Ok this is the Equip overwrite.  Basicly if you want your bots Or player to
// start with special armor you have to do it here
function SinglePlayerGame::equip(%game, %player)
{
   //ya start with nothing...NOTHING!
   %player.clearInventory();

   for(%i =0; %i<$InventoryHudCount; %i++)
   %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
   %player.client.clearBackpackIcon();

   %set = %player.client.equipment;
   if (%set == 0)
   %set = getRandom(6);
   if (%player.client == $player) %set = 0;
   
	switch (%set) {
	   case 0:
   			echo(%player.client@" Medium Medic");
			%player.setArmor("Medium");
			%player.setInventory(RepairPack, 1);
			%player.setInventory(RepairKit,1);
			%player.setInventory(ConcussionGrenade,6);
		    %player.setInventory(Plasma, 1);
		    %player.setInventory(PlasmaAmmo, 25);
	 	    %player.setInventory(Disc,1);
 		    %player.setInventory(DiscAmmo, 20);
			%player.setInventory(Elfgun, 1);
			%player.setInventory(Chaingun,1);
			%player.setInventory(ChaingunAmmo, 150);
			%player.setInventory(TargetingLaser, 1);
			%player.use("Disc");
			%player.weaponCount = 4;
	   case 1:
			echo(%player.client@" Heavy Army Man");
		   %player.setArmor("Heavy");
           %player.setInventory(RepairKit,1);
           %player.setInventory(Grenade,6);
           %player.setInventory(Mine,3);
           %player.setInventory(EnergyPack);
           %player.setInventory(Plasma, 1);
           %player.setInventory(PlasmaAmmo, 25);
           %player.setInventory(Disc,1);
           %player.setInventory(DiscAmmo, 20);
           %player.setInventory(GrenadeLauncher, 1);
           %player.setInventory(GrenadeLauncherAmmo, 1);
           %player.setInventory(MissileLauncher,1);
           %player.setInventory(MissileLauncherAmmo, 10);
           %player.setInventory(Mortar,1);
           %player.setInventory(MortarAmmo, 10);
           %player.setInventory(TargetingLaser, 1);
           %player.weaponCount = 5;
           %player.use(Mortar);
        case 2:
			echo(%player.client@" Heavy Energy Man");
			%player.setArmor("Heavy");
			%player.setInventory(RepairPack, 1);
			%player.setInventory(EnergyPack,1);
			%player.setInventory(Grenade,8);
			%player.setInventory(Mine,3);
			%player.setInventory(Chaingun, 1);
			%player.setInventory(ChaingunAmmo, 200);
			%player.setInventory(Disc,1);
			%player.setInventory(DiscAmmo, 15);
			%player.setInventory(Mortar, 1);
			%player.setInventory(MortarAmmo, 10);
			%player.setInventory(Blaster,1);
			%player.setInventory(GrenadeLauncher,1);
			%player.setInventory(GrenadeLauncherAmmo,15);
			%player.setInventory(TargetingLaser, 1);
			%player.use("Disc");
			%player.weaponCount = 5;
		case 3:
			echo("Medium Base Rape");
			%player.setArmor("Medium");
			%player.setInventory(ShieldPack, 1);
			%player.setInventory(RepairKit,1);
			%player.setInventory(Grenade,6);
			%player.setInventory(Mine,3);
			%player.setInventory(Plasma, 1);
			%player.setInventory(PlasmaAmmo, 40);
			%player.setInventory(Disc,1);
			%player.setInventory(DiscAmmo, 15);
			%player.setInventory(ElfGun, 1);
			%player.setInventory(GrenadeLauncher,1);
			%player.setInventory(GrenadeLauncherAmmo, 10);
			%player.setInventory(TargetingLaser, 1);
			%player.use("GrenadeLauncher");
			%player.weaponCount = 4;
		case 4:
			echo(%player.client@"Medium Ammo");
			%player.setArmor("Medium");
			%player.setInventory(AmmoPack, 1);
			%player.setInventory(RepairKit,1);
			%player.setInventory(Grenade,6);
			%player.setInventory(Mine,3);
			%player.setInventory(Plasma, 1);
			%player.setInventory(PlasmaAmmo, 40);
			%player.setInventory(Disc,1);
			%player.setInventory(DiscAmmo, 15);
			%player.setInventory(GrenadeLauncher, 1);
			%player.setInventory(GrenadeLauncherAmmo, 10);
			%player.setInventory(MissileLauncher,1);
			%player.setInventory(MissileLauncherAmmo, 10);
			%player.setInventory(TargetingLaser, 1);
			%player.use("Plasma");
			%player.weaponCount = 4;
		case 5:
			echo(%player.client@"Medium Demolitionist");
           	%player.setArmor("Medium");
            %player.setInventory(SatchelCharge, 1);
            %player.setInventory(RepairKit, 1);
            %player.setInventory(ConcussionGrenade, 8);
            %player.setInventory(Mine, 3);
            %player.setInventory(Plasma, 1);
            %player.setInventory(PlasmaAmmo, 40);
            %player.setInventory(Chaingun, 1);
            %player.setInventory(ChaingunAmmo, 200);
            %player.setInventory(Disc, 1);
            %player.setInventory(DiscAmmo, 15);
            %player.setInventory(GrenadeLauncher, 1);
            %player.setInventory(GrenadeLauncherAmmo, 15);
            %player.setInventory(TargetingLaser, 1);
            %player.use("Disc");
            %player.weaponCount = 4;
		case 6:
           // Derm tanker Equipment and Human Startup Equip
			echo(%player.client@"Standard Equip");
     	   %player.setArmor("Medium");
		   %player.setInventory(ShieldPack, 1);
		   %player.setInventory(RepairKit,1);
		   %player.setInventory(Grenade,6);
		   %player.setInventory(Plasma, 1);
		   %player.setInventory(PlasmaAmmo, 25);
		   %player.setInventory(Disc,1);
		   %player.setInventory(DiscAmmo, 20);
		   %player.setInventory(ElfGun, 1);
		   %player.setInventory(MissileLauncher,1);
		   %player.setInventory(MissileLauncherAmmo, 10);
		   %player.setInventory(TargetingLaser, 1);
           %player.weaponCount = 4;
		   %player.use("Disc");
		case 7:
			echo("Medium Decoy");  // --Capto
			%player.setArmor("Medium");
			%player.setInventory(SensorJammerPack, 1);
			%player.setInventory(RepairKit,1);
			%player.setInventory(ConcussionGrenade,6);
			%player.setInventory(Blaster, 1);
			%player.setInventory(Disc,1);
			%player.setInventory(DiscAmmo, 15);
			%player.setInventory(Plasma, 1);
			%player.setInventory(PlasmaAmmo, 40);
			%player.setInventory(Chaingun,1);
			%player.setInventory(ChaingunAmmo, 150);
			%player.setInventory(TargetingLaser, 1);
			%player.use("Disc");
			%player.weaponCount = 4;
     }
}

// Ok this is a funtion add-on you will have to change the Last line
// so that your package name is there
function singlePlayerGame::deactivatePackages(%game)
{
    // call the parent first then deactivate this package!
    Parent::deactivatePackages(%game);
	error("Deactivating Addon Package");
	//Deactivate packages...gotta catch'm all
	//deactivatepackage(SinglePlayer);
	deactivatepackage(CaptoTrainingSupport1);
	deactivatepackage(CaptoKantar1);
    setLogMode(0);
    $pref::trainingDifficulty = $trainingDifficulty;
}


function missionClientKilled(%victim, %killer)
{
    if (%killer == $Player)
    {
       $PlayerKills++;
       error("PlayerKills: "@$PlayerKills);
    }

    // this is handy if you dont have AI respawning I recommend it!
	if(%victim.isAIControlled() )
	{
        // this is for this mission does a count so I know how many dead!
        if (%victim.team == $enemyTeam)
        {
         $EnemyDead++;
        }
        else if (%victim.team == $playerTeam)
        {
        $FriendlyDead++;
        }
        // next line drops the client in 5 seconds do it last!
		%victim.schedule(25000,drop);
	}

}

function getTrainingPacifistMap()
{
}
//------------------------------------------------------------------------------
function beginCaptoTraining2Intro()
{
   //set the intro started bools
   $Camera::movementSpeed = 40;
//   $AIDisableChatResponse = false;
   game.playedIntro = true;
   game.trainingIntro = true;

   %group = nameToId(TankStartup);
   %Level = $pref::KantarDifficulty;
   echo("Tankttotal# "@%Level);
   %Tank2 = 0;
   %Tank3 = 0;
//   echo("$pref::KantarDifficulty :"@%Level);
   
   for(%i = 1; %i < $pref::KantarDifficulty+1; %i++){
      // oops starts at 0 not 1 but we want it to be 1 so fix or we end up with empty tank
      %location = %group.getObject(%i-1);

      %Tank[%i] = new HoverVehicle()
      {
         dataBlock  = "AssaultVehicle";
         position = %location.position;
         rotation = %location.rotation;
         scale = "1 1 1";
         respawn    = "0";
         teamBought =  2;
         team =  2;
      };
      %Tank[%i].team = 2;
      echo("Added Tank" @ %i @ ": " @ %Tank[%i]@"  Team: "@%Tank[%i].team );

   }
   //Ok this is gonna hurt, we are gonna add 6 more derms to derms already
   //on the map
   %num = $numberOfEnemies[$pref::KantarDifficulty];

// --------------------------TANK 1-------------------------------
   // Ok get the First Tank Driver
   addTankDerm(%num);
   //mount the pilot
   $Enemy[%num].pilotVehicle = true; // ??? TRUE
   $Enemy[%num].isPilot = true; // ??? TRUE
   %Tank1.mountObject($Enemy[%num].player, 0);
   $Enemy[%num].setControlObject(%Tank1);
   $TankPilot1 = $Enemy[%num];
   // OK mount the Turret guy
   %num++;

   addTankDerm(%num);

   $Enemy[%num].pilotVehicle = false;
   $Enemy[%num].isPilot = true; // ??? TRUE
   %Tank1.mountObject($Enemy[%num].player, 1);
   // make sure the turrets gonna fire
   %turret = %Tank1.getMountNodeObject(10);
   %skill = $Enemy[%num].getSkillLevel();
   %turret.setSkill(%skill);
   $Enemy[%num].turretMounted = %turret;
   %turret.setAutoFire(true);
   $TankPilot1.setPilotDestination($Tank1.position);

// --------------------------TANK 2-------------------------------
   // Ok get the Tank Driver
   //echo(%Tank2);
   if (%Tank2>0)
   {
      %num++;
      addTankDerm(%num);
      //mount the pilot
      $Enemy[%num].pilotVehicle = true; // ??? TRUE
      $Enemy[%num].isPilot = true; // ??? TRUE
      %Tank2.mountObject($Enemy[%num].player, 0);
      $Enemy[%num].setControlObject(%Tank2);
      $TankPilot2 = $Enemy[%num];
      // OK mount the Turret guy
      %num++;
      addTankDerm(%num);
      $Enemy[%num].pilotVehicle = false;
      $Enemy[%num].isPilot = true; // ??? TRUE
      %Tank2.mountObject($Enemy[%num].player, 1);
      // make sure the turrets gonna fire
      %turret = %Tank2.getMountNodeObject(10);
      %skill = $Enemy[%num].getSkillLevel();
      %turret.setSkill(%skill);
      $Enemy[%num].turretMounted = %turret;
      %turret.setAutoFire(true);
      if ($pref::KantarDifficulty = 3) %turret.selectedWeapon = 2;
      $TankPilot2.setPilotDestination($Tank3.position);
      $TankPilot2.setPilotAim($Tank2.position);
   }
// --------------------------TANK 3-------------------------------
   //echo("%Tank3"@%Tank3);
   if(%Tank3 > 0)
   {
      // Ok get the Tank Driver
      %num++;
      addTankDerm(%num);
      //mount the pilot
      $Enemy[%num].pilotVehicle = true; // ??? TRUE
      $Enemy[%num].isPilot = true; // ??? TRUE
      %Tank3.mountObject($Enemy[%num].player, 0);
      $Enemy[%num].setControlObject(%Tank3);
      $TankPilot3 = $Enemy[%num];
      // OK mount the Turret guy
      %num++;
      addTankDerm(%num);
      $Enemy[%num].pilotVehicle = false;
      $Enemy[%num].isPilot = true; // ??? TRUE
      %Tank3.mountObject($Enemy[%num].player, 1);
      // make sure the turrets gonna fire
      %turret = %Tank3.getMountNodeObject(10);
      %skill = $Enemy[%num].getSkillLevel();
      %turret.setSkill(%skill);
      $Enemy[%num].turretMounted = %turret;
      %turret.setAutoFire(true);
      %turret.selectedWeapon = 2;
      $TankPilot3.setPilotDestination($Tank3.position);
      $TankPilot3.setPilotAim($Tank2.position);
   }

   for(%i = 1; %i < %Level+1; %i++){
//      echo("%i"@%i);
      if(%Tank[%i] > 0)
      {
         $Tank[%i] = %Tank[%i];
//         echo("$Tank["@%i@"]: "@$Tank[%i]);
//         echo("$TankPilot["@%i@"]: "@$TankPilot[%i]);
         $TankPilot[%i].locationIndex = 0;
         $TankPilot[%i].addTask(AICaptoTraining2Pilot);
      }
   }

   captoTraining2ObjectiveCheck();
}

function addTankDerm(%num)
{
	%name = getUniqueEnemyName();
	%voice = "Derm"@getRandom(1,3);
	%voicePitch = 1 - ((getRandom(20) - 10)/100);
	%client = AIConnect(%name, $EnemyTeam, ($missionBotSkill[$pref::KantarDifficulty]+0.2), true, %voice, %voicePitch);
	$Enemy[%num] = %client;
     echo("Add Derm Tanker: "@$enemy[%num]);
	%client.race = "Bioderm";

	setTargetSkin(%client.target, $teamSkin[$enemyTeam]);
    %client.equipment = 6;
	game.equip(%client.player);
    // this seems redundant after equip
	%client.player.setArmor(%client.armor);
    %client.addtask(AIEngageTurretTask);
}
//------------------------------------------------------------------------------
// this is a Hack overwrite ./.. I want the turret to work!!
// but we dont need all the other checks
function Armor::AIonMount(%this, %obj, %vehicle, %node)
{
   	%client = %obj.client;

   if (%vehicle.getDataBlock().getName() $= "AssaultVehicle")
   {

      // we dont want the pilot firing off his guns while driving!
      if (%node == 0){
         %obj.unmountImage($WeaponSlot);
         %client.addTask(AIPatrolTask);
      }
      //node 1 is this vehicle's turret seat
      if (%node == 1)
      {
         %turret = %vehicle.getMountNodeObject(10);
         %skill = %client.getSkillLevel()+0.5;
         %turret.setSkill(%skill);
			%client.turretMounted = %turret;
			%turret.setAutoFire(true);
			%turret.attackRadius = 350;
            %turret.getMountedImage(0).attackRadius = 350;
      }
   }
   if (! %client.defaultTasksAdded)
   {
      %client.defaultTasksAdded = true;
      %client.addTask(AIEngageTask);
      %client.addTask(AIPickupItemTask);
      %client.addTask(AIUseInventoryTask);
      %client.addTask(AIEngageTurretTask);
      %client.addtask(AIDetectMineTask);
   }
}

function AICaptoTraining2Pilot::assume(%task, %client)
{
   %task.setWeightFreq(30);
   %task.setMonitorFreq(25);
}

function AICaptoTraining2Pilot::weight(%task, %client)
{
   %task.setWeight(10000);
}

function AICaptoTraining2Pilot::retire(%task, %client)
{
   %task.setWeight(0);
   %task.setMonitorFreq(0);
}

// ok this is what makes the tanks move
function AICaptoTraining2Pilot::monitor(%task, %client)
{
   %group = nameToId(TankPath);
//   echo("------------------Who are we moving---------------------------------");

   if (%client == $TankPilot1)
   {
      %task.locationIndex = $TankPilot1.locationIndex;
//    echo("Tank Pilot 1");
      %TankIndex = 1;
   }
   if (%client == $TankPilot2)
   {
      %task.locationIndex = $TankPilot2.locationIndex;
//    echo("Tank Pilot 2");
      %TankIndex = 2;
   }
   if (%client == $TankPilot3)
   {
      %task.locationIndex = $TankPilot3.locationIndex;
//    echo("Tank Pilot 3");
      %TankIndex = 3;
   }

   if(!%task.locationIndex)
      %task.locationIndex = 0;

//   echo("$TankPilot"@%TankIndex@".locationIndex: "@%task.locationIndex);
//   echo("%cleint: "@%client);

   // ok lets not move tanks that are 2nd and 3rd till tank1 is out there
   if (%client != $TankPilot1)
   {
//      echo("Tank 3 index: "@$TankPilot3.locationIndex);
//      echo("Tank 2 index: "@$TankPilot2.locationIndex);
//      echo("Tank 1 index: "@$TankPilot1.locationIndex);
      if ((%client == $TankPilot2) && ($TankPilot2.locationIndex+1 >= $TankPilot1.locationIndex) && $Tank1 !$= "Dead")
      {
         if(%client.vehicleMounted)
         {
//            echo("Tank 2 frozen");
            %client.stop();
            // we are gonna add a little check to see if anybody arround
            %losTimeout = $AIClientMinLOSTime + ($AIClientLOSTimeout * %client.getSkillLevel());
            %result = AIFindClosestEnemyToLoc($TankPilot[%TankIndex], $Tank[%TankIndex].vehicleMounted.position, 50, %losTimeout, true, true);
            %closestEnemy = getWord(%result, 0);
            %closestdist = getWord(%result, 1);
//          echo("------NOT MOVING CHECK!------");
//          echo("Nearest Enemy?: "@%closestEnemy);
//          echo("Nearest Enemy team?: "@%closestEnemy.team);

            if ((%closestEnemy > 0) && (%closestEnemy.team != $enemyTeam))
            {
                %client.setPilotDestination(%closestEnemy.position);
                return;
            }
            // basicly if there is no enemy dont go anywhere
            return;
         }
      }
      if ((%client == $TankPilot3) && ($TankPilot3.locationIndex+1 >= $TankPilot2.locationIndex) && ($Tank2 !$= "Dead"))
      {
         if(%client.vehicleMounted)
         {
            //echo("Tank 3 frozen");
            %client.stop();
            // we are gonna add a little check to see if anybody arround
            %losTimeout = $AIClientMinLOSTime + ($AIClientLOSTimeout * $TankPilot[%TankIndex].getSkillLevel());
            %result = AIFindClosestEnemyToLoc($TankPilot[%TankIndex], $Tank[%TankIndex].position, 50, %losTimeout, true, false);
            %closestEnemy = getWord(%result, 0);
            %closestdist = getWord(%result, 1);
//          echo("------NOT MOVING CHECK!------");
//          echo("Nearest Enemy?: "@%closestEnemy);
//          echo("Nearest Enemy team?: "@%closestEnemy.team);

            if ((%closestEnemy > 0) && (%closestEnemy.team != $enemyTeam))
            {
                %client.setPilotDestination(%closestEnemy.position);
                return;
            }
            // basicly if there is no enemy dont go anywhere
            return;
         }
      }
   }
   
   //HACK ALERT!!!
   //we need to step through all The LOCATIONS!
   %location = %group.getObject(%task.locationIndex);
   //%location = %group.getObject(%group.getCount() - 1);
   //lets not drive to the center of the map!
   if(%task.locationIndex == 0)
      %client.setPilotDestination(%location.position);

   // ever put something in the wrong place?
   if(%client == $TankPilot[%TankIndex])
   {
      // wait is shorter for higher difficulty
      if (($TankPilot[%TankIndex].locationIndex == 1) && ($CaptoTankWaitFlag[%TankIndex]==0))
      {
         %client.stop();
         $CaptoTankWaitFlag[%TankIndex] = 1;
         //we dont want the other tanks waiting at the start point to long!
         switch (%TankIndex)
         {
         case 1:
             $Tank[%TankIndex].wait = 150;  //extended
             dotext(ANY_warning01);
         case 2:
             $Tank[%TankIndex].wait = 6;
             dotext(T4_03g);
         case 3:
             $Tank[%TankIndex].wait = 6;
             dotext(ANY_warning05);
         }
//       echo("----Start with Wait 1----");
      }
      if (($TankPilot[%TankIndex].LocationIndex == 6) && ($CaptoTankWaitFlag[%TankIndex]==0))
      {
         %client.stop();
         $CaptoTankWaitFlag[%TankIndex] = 1;
         $Tank[%TankIndex].wait = 60/$pref::KantarDifficulty;
         if (%TankIndex==1)dotext(T4_07);
//       echo("----Start with Wait 2----");
      }
      if (($TankPilot[%TankIndex].LocationIndex == 7) && ($CaptoTankWaitFlag[%TankIndex]==0) && ($pref::KantarDifficulty > 1))
      {
         %client.stop();
         $CaptoTankWaitFlag[%TankIndex] = 1;
         $Tank[%TankIndex].wait = 30/$pref::KantarDifficulty;
//       echo("----Start with Wait 3----");
      }
   }

   //we start out mounted so If we are not
   if(%client.vehicleMounted)
   {
      %client.stop();
      // we are gonna add a little check to see if anybody arround
      %losTimeout = $AIClientMinLOSTime + ($AIClientLOSTimeout * %client.getSkillLevel());
      %result = AIFindClosestEnemyToLoc($TankPilot[%TankIndex], $Tank[%TankIndex].vehicleMounted.position, 100, %losTimeout, true, false);
      %closestEnemy = getWord(%result, 0);
      %closestdist = getWord(%result, 1);
//    echo("Nearest Enemy?: "@%closestEnemy);
//    echo("Nearest Enemy team?: "@%closestEnemy.team);

      if ((%closestEnemy > 0) && (%closestEnemy.team != $enemyTeam))
      {
         %client.setPilotDestination(%closestEnemy.position);
         return;
      }
      else if ($TankPilot[%TankIndex].locationIndex >= 11)
      {
         switch (%TankIndex)
         {
         case 1:
            %endlocation = nameToId(Tank1Finish);
         case 2:
            %endlocation = nameToId(Tank2Finish);
         case 3:
            %endlocation = nameToId(Tank3Finish);
         }
         // ok lets see if we are on our end
         %pos = %client.vehicleMounted.position;
         %pos2D = getWord(%pos, 0) SPC getWord(%pos, 1) SPC "0";
         %dest =  %endlocation.position;
         %dest2D = getWord(%dest, 0) SPC getWord(%dest, 1) SPC "0";
         if (VectorDist(%dest2D, %pos2D) < 20)
         {
            $Tank[%TankIndex].AtFinal = true;
    	    %client.setPilotAim(%group.getObject(6).position);
            %client.stop();
            AIDisembarkVehicle(%client);
            missionFailed($player.miscMsg[TankEscaped]);
            return;
         }
         else
         {
             $Tank[%TankIndex].AtFinal = false;
         }
         %client.setPilotDestination(%endlocation.position);
      }
      else
      {
         //else see if we're close enough to the current destination to choose the next
         %pos = %client.vehicleMounted.position;
         %pos2D = getWord(%pos, 0) SPC getWord(%pos, 1) SPC "0";
         %dest =  %group.getObject(%task.locationIndex).position;
         %dest2D = getWord(%dest, 0) SPC getWord(%dest, 1) SPC "0";
//       echo("Tank Wait State : "@ $CaptoTankWaitFlag);
         if ($CaptoTankWaitFlag[%TankIndex] > $Tank[%TankIndex].wait)
         {
//           echo("----Done with Wait ----");
             $CaptoTankWaitFlag[%TankIndex] = 0;
             $TankPilot[%TankIndex].locationIndex++;
             %client.setPilotDestination(%location.position);
             return;
         }
         else if ($CaptoTankWaitFlag[%TankIndex] > 0)
         {
            %client.stop();
            %client.setPilotAim(%group.getObject(10).position);
            $CaptoTankWaitFlag[%TankIndex]++;
            return;
         }
         %client.setPilotDestination(%location.position);

         if (VectorDist(%dest2D, %pos2D) < 20)
         {
            if(%group.getCount() > %task.locationIndex + 1)
            {
//             echo("---Stepping Index for Tank "@%TankIndex@".");
               $TankPilot[%TankIndex].locationIndex++;
            }
         }
      }
   }
   else
   {
//    echo("Tank" @%TankIndex@": "@$Tank[%TankIndex]);
      AIUnassignClient(%client);
      %client.clearTasks();
      %client.defaultTasksAdded = true;
      %client.addTask(AIEngageTask);
      %client.addTask(AIPickupItemTask);
      %client.addTask(AIUseInventoryTask);
      %client.addTask(AIEngageTurretTask);
      %client.addtask(AIDetectMineTask);
      Game.AIChooseGameObjective(%Client);
      //echo("----------Moving Hell we are dead!---------");
      return;
   }

}

function SinglePlayerGame::vehicleDestroyed(%game, %vehicle, %destroyer)
{
    // Ok we need to trap the Vehicle that was distroyed
//    echo("Vehicle: "@%vehicle);
   if (%vehicle == $Tank1)
   {
//       echo("Tank 1 Dead");
         $Tank1 = "Dead";
   }
   if (%vehicle == $Tank2)
   {
//       echo("Tank 2 Dead");
         $Tank2 = "Dead";
   }
   if (%vehicle == $Tank3)
   {
//       echo("Tank 3 Dead");
         $Tank3 = "Dead";
   }

    //vehicle name
    %data = %vehicle.getDataBlock();
    //%vehicleType = getTaggedString(%data.targetNameTag) SPC getTaggedString(%data.targetTypeTag);
    %vehicleType = getTaggedString(%data.targetTypeTag);
    if(%vehicleType !$= "MPB")
        %vehicleType = strlwr(%vehicleType);

    %enemyTeam = ( %destroyer.team == 1 ) ? 2 : 1;

    %scorer = 0;
    %multiplier = 1;

    %passengers = 0;
    for(%i = 0; %i < %data.numMountPoints; %i++)
        if(%vehicle.getMountNodeObject(%i))
            %passengers++;

    //what destroyed this vehicle
    if(%destroyer.client)
    {
        //it was a player, or his mine, satchel, whatever...
        %destroyer = %destroyer.client;
        %scorer = %destroyer;

        // determine if the object used was a mine
        if(%vehicle.lastDamageType == $DamageType::Mine)
            %multiplier = 2;
    }
    else if(%destroyer.getClassName() $= "Turret")
    {
        if(%destroyer.getControllingClient())
        {
            //manned turret
            %destroyer = %destroyer.getControllingClient();
            %scorer = %destroyer;
        }
        else
        {
            %destroyerName = "A turret";
            %multiplier = 0;
        }
    }
    else if(%destroyer.getDataBlock().catagory $= "Vehicles")
    {
        // Vehicle vs vehicle kill!
        if(%name $= "BomberFlyer" || %name $= "AssaultVehicle")
            %gunnerNode = 1;
        else
            %gunnerNode = 0;

        if(%destroyer.getMountNodeObject(%gunnerNode))
        {
            %destroyer = %destroyer.getMountNodeObject(%gunnerNode).client;
            %scorer = %destroyer;
        }
        %multiplier = 3;
    }
    else  // Is there anything else we care about?
        return;


    if(%destroyerName $= "")
        %destroyerName = %destroyer.name;

    if(%vehicle.team == %destroyer.team) // team kill
    {
        %pref = (%vehicleType $= "Assault Tank") ? "an" : "a";
        messageAll( 'msgVehicleTeamDestroy', '\c0%1 TEAMKILLED %3 %2!', %destroyerName, %vehicleType, %pref);
    }

    else // legit kill
    {
        messageTeamExcept(%destroyer, 'msgVehicleDestroy', '\c0%1 destroyed an enemy %2.', %destroyerName, %vehicleType);
        messageTeam(%enemyTeam, 'msgVehicleDestroy', '\c0%1 destroyed your team\'s %2.', %destroyerName, %vehicleType);
        //messageClient(%destroyer, 'msgVehicleDestroy', '\c0You destroyed an enemy %1.', %vehicleType);
    }
}
// Ok this is one hell of a hack..  the AI dont like to fire Mortors
// so i reversed the Triggers
function AssaultPlasmaTurret::onTrigger(%data, %obj, %trigger, %state)
{
   switch (%trigger) {
      case 0:
         %obj.fireTrigger = %state;
         if(%obj.selectedWeapon == 1)
         {
            %obj.setImageTrigger(2, false);
            if(%state)
               %obj.setImageTrigger(4, true);
            else
               %obj.setImageTrigger(4, false);
         }
         else
         {
            %obj.setImageTrigger(4, false);
            if(%state)
               %obj.setImageTrigger(2, true);
            else
               %obj.setImageTrigger(2, false);
         }
      case 2:
         if(%state)
         {
            %obj.getDataBlock().playerDismount(%obj);
         }
   }
}

function captoTraining2ObjectiveCheck()
{
   echo("*****************************************************ObjectiveCheck");
   $DeadTank = 0;
   $Failed = 0;
   for(%i = 1; %i < $pref::KantarDifficulty+1; %i++)
   {
      if($Tank[%i] == "Dead") $DeadTank++;
      if($Tank[%i].AtFinal == true) missionFailed($player.miscMsg[TankEscaped]);
   }
 echo("$EnemyDead: "@$EnemyDead);
// echo("$Failed: "@$Failed);
 echo("$DeadTank: "@$DeadTank);

   if ($Failed == 1) missionFailed($player.miscMsg[TankEscaped]);

   if ($DeadTank == $pref::KantarDifficulty)
   {
      %totalenemy = $pref::KantarDifficulty*2 + $numberOfEnemies[$pref::KantarDifficulty];

      if ($CTKillFlag == 0)
      {
         $CTKillFlag = 1;
         // lets set one hell of an objective so the derms all attack base
         $FinalObjective = new AIObjective(AIOAttackLocation)
            {
			position = "-29.0212 -52.6233 154.759";
			rotation = "1 0 0 0";
			scale = "1 1 1";
			dataBlock = "AIObjectiveMarker";
			lockCount = "0";
			homingCount = "0";
			targetClientId = "-1";
			targetObjectId = "-1";
			location = "-29.0212 -52.6233 154.759";
			weightLevel1 = 4675;
			weightLevel2 = 4675;
			weightLevel3 = 4675;
			weightLevel4 = 4675;
			offense = "0";
			defense = "1";
			issuedByHuman = "0";
			issuedByClientId = "-1";
			forceClientId = "-1";
            };
         addAIObjective(2, $FinalObjective);
         $ObjectiveQ[2].add($FinalObjective);
         // clear the derms and reset to force the new objective
         DermClearObjective();
         for( %x = 1; %x <= %totalenemy; %x++ )
         {
            if ($enemy[%x])
            {
               %oldObjective = $enemy[%x].objective;
               AIUnassignClient($enemy[%x]);
               AIForceObjective($enemy[%x], %newObjective, 4675);
               //echo("ObjectiveID: "@%newObjective);
              // echo("ObjectiveID: "@$enemy[%x].objective);
            }
         }
      }
      if ($CTKillFlag == 1){
         for( %x = 1; %x <= %totalenemy; %x++ ){
            if ($enemy[%x]){
               if ($enemy[%x].objective != $FinalObjective){
                  %oldObjective = $enemy[%x].objective;
                  AIUnassignClient($FinalObjective[%x]);
                  //deleting old objective should make it so derms cant reset it
                  if ((%oldObjective != $FinalObjective) && (%oldObjective)) %oldObjective.delete();
                  AIForceObjective($enemy[%x], $FinalObjective, 4675);
               }
            }
         }
      }
      //echo("$totalenemy: "@%totalenemy);
      if ($EnemyDead >= %totalenemy)
      {
         dotext(ANY_kudo04);
         missionComplete($player.miscMsg[DermsDead]);
         return;
      }
   }

   $player.ObjectiveCheck = schedule(5000, game, captoTraining2ObjectiveCheck);
}

function DermClearObjective()
{
   %totalenemy = $pref::KantarDifficulty*2 + $numberOfEnemies[$pref::KantarDifficulty];
   for( %x = 1; %x <= %totalenemy; %x++ ){
      if ($enemy[%x]){
         AIUnassignClient($enemy[%x]);
      }
   }
}

//--CaptoTraining2 package END -----------------------------------------------------------------
};
