//------------------------------------------------------------------------------
//
// KantarGui.cs
//
//------------------------------------------------------------------------------
// Ok apparently we have to do this:
// All else failed so we break down and screw with the function itself
//exec("gui/KantarGui.gui");
new GuiControlProfile ("KantarBriefingProfile")
{
   fontType = "Univers";
   fontSize = 18;
   fontColor = "173 255 250";
   justify = "left";
};

$Kantar = 0;
package Kantar {
function LaunchToolbarMenu::onSelect(%this, %id, %text)
{
    parent::onSelect(%this, %id, %text);
    if (%id==21)
        LaunchKantar();
}
function LaunchToolbarDlg::onWake(%this)
{
//    error("On wake LaunchToolbar for Kantar!!!");
    parent::onWake(%this);
//    error("AfterParent");
    LaunchToolbarMenu.addSeparator();
    LaunchToolbarMenu.add(21, "KANTAR");
    LaunchToolbarMenu.addSeparator();
}
function OpenLaunchTabs( %gotoWarriorSetup )
{
   parent::OpenLaunchTabs( %gotoWarriorSetup );
   if ( $Kantar == 1)
      return;
   KantarGuiStart();
   LaunchTabView.addLaunchTab( "KANTAR",    KantarGui );
   $Kantar = 1;
   //ARRRG this is to fix a stupid Error
   if ($pref::KantarDifficulty=="")
      $pref::KantarDifficulty = 1;
   if ($pref::TrainingDifficulty=="")
      $pref::TrainingDifficulty = 1;
}

};
//------------------------------------------------------------------------------
// There is no package here because we are making new functions not changing any
function LaunchKantar()
{
   LaunchTabView.viewTab( "KANTAR", KantarGui, 0 );
}

//------------------------------------------------------------------------------
function KantarGui::onWake( %this )
{
   Canvas.pushDialog( LaunchToolbarDlg );

	%this.soundHandle = 0;
	%this.briefEventCount = 0;
	%this.briefWAV = "";
   %ct = 1;
	%fobject = new FileObject();
   %search = "missions/*.mis";
   KantarMissionList.clear();
   for ( %file = findFirstFile( %search ); %file !$= ""; %file = findNextFile( %search ) )
   {
      %name = fileBase(%file); // get the mission name

      if ( !%fobject.openForRead( %file ) )
         continue;

		%typeList = "None";

      while( !%fobject.isEOF() )
      {
         %line = %fobject.readLine();
         if ( getSubStr( %line, 0, 18 ) $= "// MissionTypes = " )
         {
            %typeList = getSubStr( %line, 18, 1000 );
            break;
         }
      }

		if ( strstr( %typeList, "Kantar" ) != -1 )
      {
         // Get the mission display name:
         %displayName = %name;
         while ( !%fobject.isEOF() )
         {
            %line = %fobject.readLine();
            if ( getSubStr( %line, 0, 17 ) $= "// DisplayName = " )
            {
               %displayName = getSubStr( %line, 17, 1000 );
               // Strip the date:
               %pos = strpos( %displayName, "," );
               if ( %pos != -1 )
                  %displayName = getSubStr( %displayName, 0, %pos );
               break;
            }
         }

      	KantarMissionList.addRow( %ct++, %displayName TAB %name );
      }

      %fobject.close();
   }

	KantarMissionList.sort( 1 );
   KantarMissionList.setSelectedRow( 0 );
   if ( $pref::KantarDifficulty > 0 && $pref::KantarDifficulty < 4 )
      KantarDifficultyMenu.setSelected( $pref::KantarDifficulty );
   else
      KantarDifficultyMenu.setSelected( 1 );
}

//------------------------------------------------------------------------------
function KantarGui::onSleep( %this )
{
	%this.stopBriefing();

	Canvas.popDialog(LaunchToolbarDlg);
}

//------------------------------------------------------------------------------
function KantarGui::setKey( %this )
{
}

//------------------------------------------------------------------------------
function KantarGui::onClose( %this )
{
}

//------------------------------------------------------------------------------
function KantarDifficultyMenu::onAdd( %this )
{
   %this.add( "Easy", 1 );
   %this.add( "Medium", 2 );
   %this.add( "Hard", 3 );
}

//------------------------------------------------------------------------------
function KantarDifficultyMenu::onSelect( %this, %id, %text )
{
   $pref::KantarDifficulty = %id;
}

//------------------------------------------------------------------------------
function KantarMissionList::onSelect( %this, %id, %text )
{
   KantarGui.stopBriefing();
   %fileName = "missions/" @ getField( %text, 1 ) @ ".mis";
   %file = new FileObject();
   %state = 0;
   if ( %file.openForRead( %fileName ) )
   {
	 // Get the mission briefing text:
      while ( !%file.isEOF() )
      {
         %line = %file.readLine();
         if ( %state == 0 && %line $= "//--- MISSION BRIEFING BEGIN ---" )
            %state = 1;
         else if ( %state > 0 && %line $= "//--- MISSION BRIEFING END ---" )
            break;
         else if ( %state == 1 )
			{
            %briefText = %briefText @ getSubStr( %line, 2, 1000 );
				%state = 2;
			}
         else if ( %state == 2 )
            %briefText = %briefText NL getSubStr( %line, 2, 1000 );
      }

      // Get the mission briefing WAV file:
	 while ( !%file.isEOF() )
      {
         %line = %file.readLine();
         if ( getSubStr( %line, 0, 17 ) $= "// BriefingWAV = " )
         {
            %briefWAV = getSubStr( %line, 17, 1000 );
             break;
         }
	 }

      // Get the bitmap name:
      while ( !%file.isEOF() )
      {
         %line = %file.readLine();
         if ( getSubStr( %line, 0, 12 ) $= "// Bitmap = " )
         {
            %briefPic = getSubStr( %line, 12, 1000 );
            break;
         }
      }
      // Get the background bitmap name:
      while ( !%file.isEOF() )
      {
         %line = %file.readLine();
         if ( getSubStr( %line, 0, 12 ) $= "// BmpBck = " )
         {
            %BmpBck = getSubStr( %line, 12, 1000 );
            break;
         }
      }
      %file.close();
   }
   else
      error( "Failed to open Single Player mission file " @ %fileName @ "!" );

   %Briefbmp = "gui/" @ %briefPic @ ".png";
   error("Planet Pic: "@%Briefbmp);
   if ( isFile( "textures/" @ %Briefbmp ) )
   {
      KantarPic.setBitmap( %Briefbmp );
      KantarPicFrame.setVisible( true );
   }
   else
   {
      KantarPic.setBitmap( "" );
      KantarPicFrame.setVisible( false );
   }

   //Text background picture
   %BmpBckBmp = "gui/" @ %BmpBck @ ".png";
   error("Background Pic: "@%BmpBckBmp);
   if ( isFile( "textures/" @ %BmpBckBmp ) )
   {
      KantarBackGround.setBitmap( %BmpBckBmp );
      KantarBackgroundFrame.setVisible( true );
   }
   else
   {
      KantarBackGround.setBitmap( "" );
      KantarBackgroundFrame.setVisible( false );
   }

   KantarPlayBtn.setActive( %briefWAV !$= "" );
   KantarBriefingText.setValue( %briefText );
   KantarBriefingScroll.scrollToTop();
   KantarGui.WAVBase = firstWord( %briefWAV );
   KantarGui.WAVCount = restWords( %briefWAV );
   %file.delete();

   //if ( TrainingPlayTgl.getValue() )
   //   TrainingGui.startBriefing();
}

//------------------------------------------------------------------------------
function KantarPlayTgl::onAction( %this )
{
   if ( %this.getValue() )
   {
      if ( KantarMissionList.getSelectedId() != -1 )
         KantarGui.startBriefing();
   }
   else
      KantarGui.stopBriefing();
}

//--------------------------------------------------------
function KantarGui::toggleBriefing( %this )
{
   if ( %this.soundHandle $= "" )
      %this.startBriefing();
   else
      %this.stopBriefing();
}

//--------------------------------------------------------
function KantarGui::startBriefing( %this )
{
	%this.stopBriefing();
   if ( %this.WAVBase !$= "" )
   {
      %this.instance = %this.instance $= "" ? 0 : %this.instance;
	   %this.playNextBriefWAV( %this.WAVBase, 0, %this.WAVCount, %this.instance );
   }
}

//--------------------------------------------------------
function KantarGui::playNextBriefWAV( %this, %wavBase, %id, %count, %instance )
{
	if ( %instance == %this.instance )
	{
      if ( %id < %count )
      {
		   %wav = "voice/Kantar/Briefings/" @ %wavBase @ ".brief0" @ ( %id + 1 ) @ ".wav";
	      %this.soundHandle = alxCreateSource( AudioGui, %wav );
	      alxPlay( %this.soundHandle );

	      // Schedule the next WAV:
		   %delay = alxGetWaveLen( %wav ) + 500;
		   %this.schedule( %delay, playNextBriefWAV, %wavBase, %id + 1, %count, %instance );
      }
      else
      {
         // We're all done!
         %this.soundHandle = "";
      }
	}
}

//--------------------------------------------------------
function KantarGui::stopBriefing( %this )
{
	if ( %this.soundHandle !$= "" )
	{
		alxStop( %this.soundHandle );
		%this.soundHandle = "";
		%this.instance++;
	}
}

//--------------------------------------------------------
function KantarGui::startKantar( %this )
{
   MessagePopup( "STARTING MISSION", "Initializing, please wait..." );
   Canvas.repaint();
   cancelServerQuery();
   %file = getField( KantarMissionList.getValue(), 1 );
   //Ok just so you know its still uses Single Player Stuff
   //No redundant scripts here
	$ServerName = "Kantar Missions";
   $HostGameType = "SinglePlayer";
   CreateServer( %file, "SinglePlayer" );
	%playerPref = $pref::Player[$pref::Player::Current];
	%playerName = getField( %playerPref, 0 );
	%playerRaceGender = getField( %playerPref, 1 );
	%playerSkin = getField( %playerPref, 2 );
	%playerVoice = getField( %playerPref, 3 );
	%playerVoicePitch = getField( %playerPref, 4 );
   // no derms fighting derms!
   if (%playerRaceGender == "BioDerm")
      %playerRaceGender = "Human Male";
   localConnect( %playerName, %playerRaceGender, "swolf", %playerVoice, %playerVoicePitch );
//   localConnect( "Lone Wolf", "Human Male", "swolf", "Male1" );
}
//--------------------------------------------------------
activatePackage(Kantar);

function KantarGuiStart()
{
if(!isobject(KantarGui))
{
new GuiChunkedBitmapCtrl(KantarGui) {
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	variable = "$ShellBackground";
	helpTag = "0";
	useVariable = "1";

	instance = "29";
	briefEventCount = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "12 13";
		extent = "620 423";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "KANTAR";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellFieldCtrl(KantarPicFrame) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 35";
			extent = "169 169";
			minExtent = "16 18";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiBitmapCtrl(KantarPic) {
				profile = "GuiDefaultProfile";
				horizSizing = "width";
				vertSizing = "height";
				position = "0 0";
				extent = "169 169";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				wrap = "0";
			};
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "265 376";
			extent = "58 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Difficulty:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(KantarDifficultyMenu) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "307 368";
			extent = "137 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellScrollCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "height";
			position = "26 204";
			extent = "176 192";
			minExtent = "24 52";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			willFirstRespond = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "dynamic";
			constantThumbHeight = "0";
			defaultLineHeight = "15";
			childMargin = "3 3";
			fieldBase = "gui/shll_field";

			new GuiScrollContentCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "height";
				position = "7 7";
				extent = "162 178";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new ShellTextList(KantarMissionList) {
					profile = "ShellAltTextProfile";
					horizSizing = "right";
					vertSizing = "height";
					position = "0 0";
					extent = "162 144";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					enumerate = "1";
					resizeCell = "1";
					columns = "0 200";
					fitParentWidth = "1";
					clipColumnText = "0";
				};
			};
		};
		new ShellToggleButton(KantarPlayTgl) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "448 27";
			extent = "140 30";
			minExtent = "32 15";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::KantarPlayBriefing";
			helpTag = "0";
			text = "Play Briefing";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "444 31";
			extent = "122 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Play Briefing:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton(KantarPlayBtn) {
			profile = "SoundTestButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "564 28";
			extent = "28 38";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "KantarGui.toggleBriefing();";
			helpTag = "0";
			simpleStyle = "1";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "219 31";
			extent = "99 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "MISSION BRIEFING";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellScrollCtrl(KantarBriefingScroll) {
			profile = "GuiDefaultProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "214 50";
			extent = "378 318";
			minExtent = "24 52";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			willFirstRespond = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			constantThumbHeight = "0";
			defaultLineHeight = "15";
			childMargin = "3 3";
			fieldBase = "gui/shll_field";

			new GuiScrollContentCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "width";
				vertSizing = "height";
				position = "7 7";
				extent = "348 304";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

              		new ShellFieldCtrl(KantarBackgroundFrame) {
              			profile = "GuiDefaultProfile";
              			horizSizing = "width";
              			vertSizing = "height";
              			position = "0 0";
                         extent = "350 305";
              			minExtent = "16 18";
              			visible = "0";
              			hideCursor = "0";
              			bypassHideCursor = "0";
              			helpTag = "0";

              			new GuiBitmapCtrl(KantarBackGround) {
              				profile = "GuiDefaultProfile";
              				horizSizing = "width";
              				vertSizing = "height";
              				position = "0 0";
                              extent = "350 305";
              				minExtent = "8 8";
              				visible = "1";
              				hideCursor = "0";
              				bypassHideCursor = "0";
              				helpTag = "0";
              				wrap = "0";

              				new GuiMLTextCtrl(KantarBriefingText) {
              					profile = "KantarBriefingProfile";
              					horizSizing = "width";
              					vertSizing = "height";
              					position = "0 0";
              					extent = "350 305";
              					minExtent = "8 8";
              					visible = "1";
              					hideCursor = "0";
              					bypassHideCursor = "0";
              					helpTag = "0";
              					lineSpacing = "2";
              					allowColorChars = "0";
              					maxChars = "-1";
                              };
                         };
				};
			};
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "469 368";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "KantarGui.startKantar();";
			helpTag = "0";
			text = "START";
			simpleStyle = "0";
		};
	};
};
}
}
